# Arduinos in Space changelog

* **2019-03-08**: v1.0
  * Pulling requests and commands from the `serial_commands.txt` file
	generated by the game, rather than unofficial lists.
  * Ensure `_maxCommand` is actually higher than the number of
	requests we support.
* **2018-08-16**: v0.8.1
  No user-visible changes.
  * Most constants moved from globals to the class that requires them.
  * All public classes, methods, interfaces should have doxygen docs.
  * library.properties and library.json updated to prep for Arduino and
	platformio library managers.
* **2018-08-04**: v0.8
  * Modifies how trigger inputs are handled, fixing bugs with single-input
	triggers.
  * Now respecting the maximum size of the managed input pin array.
  * New input polling method for managed inputs. Smaller code size, and
	should be more responsive, especially on busier consoles.
  * Library version is now included in the debug message on connection
	activation. The game logs this message, aiding debugging.
* **2018-08-04**: v0.7.1
  * Ensure arrays of requests and managed input pins are explicitly
    initialised, preventing crashes on some platforms.
* **2018-07-24**: v0.7
  * Optional input pin handling.
    * registerTrigger() will register a command to be sent when the input
	  pin is active, and an optional second when the input pin is inactive.
	* registerLatching() will register two commands and alternate between
	  them each time the input is made active.
	Both modes can put a pin in INPUT or INPUT_PULLUP mode and work with
	NO switches in the expected fashion.
  * Some tidying up of documentation.
* **2018-07-14**: v0.6.1
  Fixes a bug that crept in to CommandDemo.
* **2018-07-05**: v0.6
  * Optional output pin management for Boolean data requests. Instead
    of passing a callback function to requestBool(), you can pass a
    pin number, and ArduinosInSpace will set the pin state automatically
    when data is received from the game. This mode has an optional
    `invert` parameter to invert the logic. The old requestBool()
    functionality is still there.
  * Example sketches have gotten an upgrade:
    * New `HelloWorld` sketch, demonstrates basic usage with no
      extra hardware required. Based on a demo written by smt923.
    * `CommandDemo`. Demonstrating sending commands to the game.
      This sketch removes the dependence on an extra library, instead
      acting as an extension to the standard Arduino `Debounce`
      tutorial.
    * `BooleanRequests`. Demonstrates the different ways to handle
      boolean data from the game; pin management mode and callback
      mode.
    * `OiSLCD`. Requests telemetry from the game and displays it
      on an LCD. Based on a demo project by LeahNudle.
* **2018-06-30**: v0.5.1
  * Cleaning up: Almost entirely warning-free.
* **2018-06-21**: v0.5
  * Replaced serial parser.
  * Better error checking on serial input.
* **2018-06-18**: v0.4.1
  * Send correct command for float request.
  * Convert float data properly.
* **2018-06-13**: v0.4
  * Added some debug code with an error callback. `#define OIS_DEBUG`,
    then add a callback using the `errorHandler()` method, and the
    callback will be called when errors are caught. Currently only
    alerts when the serial receive buffer is full.
  * Shuffled some code around for tidyness.
* **2018-06-12**: v0.3
  * Added `registerBoolRaw()`, `registerIntRaw()`, `registerFloatRaw()`
    to handle data requests with a "raw" callback - this callback
    receives the int from the game directly with no postprocessing.
  * All register functions now return an int instead of a boolean.
    This int represents the channel ID of the request - it correlates
    to the channel int passed to callbacks. A return value of -1
    indicates failure - the channel was not registered. This is a
    breaking change.
  * Refactoring of the registration code. Even with the other changes
    existing example sketches clock in at a handful of bytes smaller.
* **2018-06-11**: v0.2
  * Library now handles conversion of data from the game to the desired
    type - boolean callbacks receive a bool and float callbacks receive
    an adjusted float. This is a breaking change for anything that
    requests data from the game.
* **2018-06-09**: v0.1.1
  * Optimising send buffer.
  * Implementing the channels I forgot about last time. :/
* **2018-06-08**: v0.1.0
  Initial release

